#pragma once
#include <BasicAbstractions/IPreparable.h>
#include <States/GameState/Maze/Room/Room.h>

class IEntity : public IPreparable {
public:
    virtual void prepare_for_first_drawing() = 0;
    void set_initial_location(Room* ptr_room) {
        m_ptr_room = ptr_room;
        prepare_for_first_drawing();
    }
    void set_location(Room* ptr_room) {
        m_ptr_room = ptr_room;
        prepare_for_drawing();
    }
    [[nodiscard]] Room* get_location() const noexcept { return m_ptr_room; }
protected:
    Room* m_ptr_room = nullptr;
};