#pragma once
#include <States/GameState/Entities/IEntity.h>
#include <States/GameState/Entities/IVisitor.h>

class Pacman final : public IEntity, public IVisitor {
public:
    Pacman();
    void replace(Room::Direction direction);
    void move();
    void draw_into(sf::RenderWindow& window) const override;
    void prepare_for_first_drawing() override;
    void prepare_for_drawing() override;
    sf::FloatRect getBounds() const { return m_circle.getGlobalBounds(); }
    std::unique_ptr<IGameEvent> visit(Food* ptr_food) override;
    std::unique_ptr<IGameEvent> visit(Enemy* ptr_enemy) override;
private:
    sf::CircleShape m_circle;
    sf::Vector2f m_estimated_position;
    float m_distance_limit;
    bool m_is_moving = false;
    sf::Clock m_stopwatch;
};