#pragma once
#include <Configuration.h>
#include <BasicAbstractions/IWindowKeeper.h>
#include "Menu.h"

class SelectState final : public IState, public IWindowKeeper {
public:
    explicit SelectState(IStateManager& state_manager, const sf::VideoMode& video_mode, const sf::String& window_title) :
    IState(state_manager), IWindowKeeper(video_mode, window_title), m_menu(state_manager) {
        m_window.setFramerateLimit(config::FRAME_RATE_LIMIT);
    }
    bool do_step() override;
private:
    void event_handling() override;
    void update() override;
    void render() override;
private:
    Menu m_menu;
};

